/*
 *  WAC  2/13/00  -- cloned from DISKFILE.H, changes to add:
 *                       1) Comment field
 *                       2) Directory entries with ZIP/ARC name
 *                             expansion
 */

#define TRUE 1
#define FALSE 0

#define FILE_ERROR -1

typedef unsigned char BYTE;
typedef unsigned int WORD;
typedef long DWORD;

BYTE sig[] = "WC DISK IMAGE\032\032";  /* 16 chars with EOS */

#define VERSION 1   /* change this for incompatible versions */

struct hdr_format
   {
   BYTE signature[16];
   BYTE version;      /* these 2 bytes are DX */
   BYTE headcount;
   BYTE sectorcount;  /* these 2 bytes are CX */
   BYTE cylcount;
   BYTE head0extra1;  /* 1st extra track on head 0 present */
   BYTE head1extra1;  /* 1st extra track on head 1 present */
   BYTE head0extra2;  /* 2nd extra track on head 0 present */
   BYTE head1extra2;  /* 2nd extra track on head 1 present */
   BYTE extrasflag;   /* flags: has comments, directories (see below) */
   BYTE reserved[7];  /* makes the header 32-bytes long */
   };

#define SFLAG_NORMAL 0    /* just standard data */
#define SFLAG_BAD 1       /* Unable to read sector, no CRC, no data */
#define SFLAG_REPEAT 2    /* repeating data byte in sector, no data attached,
                             use lowbyte of CRC for data fill */
#define SFLAG_COMMENT 3   /* comments field (only 1 block)
                             CRC is string length */
#define SFLAG_DIR 4       /* directory field (may have more than 1 block, all
                             are treated as contiguous text fields)
                             CRC is string length */


#define EFLAG_COMMENT 0x01  /* extrasflag: has comment block after data */
#define EFLAG_DIR     0x02  /* extrasflag: has directory field after data */


struct sect_hdr
   {
   BYTE flags;    /* would be DL=drive, but use it for flags instead */
   BYTE head;     /* DH */
   BYTE sector;   /* CL */
   BYTE cyl;      /* CH */
   WORD crc;      /* or DATA, depnding on flags */
   };

#define SECTOR_SIZE 512  /* 512 bytes/sector for standard disk */
#define MAX_SPT 18   /* max SPT program will handle, this is a 1.44M disk */
#define MAX_CYL 80   /* max cyls program will handle, this is 1.2M/1.44M/720K disk */
#define MAX_CYL_360 40  /* max cyls for a 360K floppy */
#define MAX_HEADS 2  /* max heads for a floppy */
#define SPT_144 18  /* SPT for a 1.44M floppy */
#define SPT_12 15  /* SPT for a 1.2M floppy */
#define SPT_720360 9  /* SPT for a 720K or 360K or 180K floppy */
#define SPT_320160 8  /* SPT for a 320K or 160K floppy */

#define ARJ_MAX_HEADER_SIZE 2600  /* from UNARJ TECHNOTE.DOC, April 1993 */

/* #define DISKBUF_SIZE (MAX_SPT * SECTOR_SIZE) */
#define DISKBUF_SIZE 32768
#define OUTBUF_SIZE (MAX_SPT * (SECTOR_SIZE + sizeof(struct sect_hdr)))
   /* NOTE: MAX_SPT * SECTOR_SIZE > ARJ_MAX_HEADER_SIZE */

#define DISK_READ 2
#define DISK_WRITE 3
#define DISK_FORMAT 5

#define MODE_READ 0
#define MODE_READWRITE 2

#define MEMFILL(s,n,c) _setmem(s,n,c)

#define LSEEK_BOF 0
#define LSEEK_CURRENT 1
#define LSEEK_EOF 2
